/* registration.h -- helps in registering RCS ids of each file */
/* Copyright (C) 1995 Ari Mujunen. (amn@nfra.nl, Ari.Mujunen@hut.fi) */

/* This is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License. */
/* See the file 'COPYING' for details. */

/*
 * $Log: registration.h,v $
 * Revision 1.4  1998/05/29 05:51:14  amn
 * Comment leader of log lines changed.
 *
 * Revision 1.3  1997/03/10 08:59:31  amn
 * Had to make use of 'rcsid_##file' more complicated as GCC 2.7.2
 * had acquired new talents in recognizing dummy uses of variables.
 *
 * Revision 1.2  1995/03/20 15:01:04  amn
 * Changed from C++-style comments to ordinary C comments
 * to make this file usable from both C and C++.
 *
 * Revision 1.1  1995/02/11  19:54:27  amn
 * Initial revision
 *
 */


#ifndef _registration_h
#define _registration_h 1

/* By embedding static variables containing the RCS special strings */
/* in the format "$Id xxx$", the resulting object code and executables */
/* can be examined with the command 'ident'.  This macro takes care */
/* of both defining the static variable and using it, so we don't */
/* get extra warnings of unused variables in GCC. */

#define RCSID(file, id) \
static char rcsid_##file[] = id; \
static volatile void * use_rcsid_##file = (!rcsid_##file ? &use_rcsid_##file : (void *) &rcsid_##file)

RCSID(registration_h, "$Id: registration.h,v 1.4 1998/05/29 05:51:14 amn Exp $");

#endif
